#define UNPACK(src, t1, t2) \
    xor t1, t1, t1      ;\
    or  src, src, t1    ;\
    andi t1, 0xffff, t1 ;\
    xor t2, t2, t2      ;\
    or  src, src, t2    ;\
    srli t2, 16, t2

// src1 and src2 are not maintained
#define PACK(src1, src2, t1) \
    andi src1, 0xffff, t1    ;\
    andi src2, 0xffff, src2  ;\
    slli src2, 16, src2      ;\
    or   src2, t1, t1        

#define PACKC(c1, c2, t1)   \
    xor     t1, t1, t1  ;\
    ori     t1, c1, t1  ;\
    slli    t1, 16, t1  ;\
    ori     t1, c2, t1

// registers r8-r11 are modified.
#define DOTPRODUCTC(src1, src2, c1, c2, c3, c4, t1) \
    UNPACK(src1, r8, r9)    ;\
    UNPACK(src2, r10, r11)  ;\
    muli    r8, c1, r8      ;\
    muli    r9, c2, r9      ;\
    muli    r10, c3, r10    ;\
    muli    r11, c4, r11    ;\
    add     r8, r9, r8      ;\
    add     r10, r11, r10   ;\
    add     r8, r10, r8     ;\
    srli    r8, 8, t1


#define MV_MULC(sd1, sd2, c0,c1,c2,c3, c4,c5,c6,c7, c8,c9,c10,c11, c12,c13,c14,c15)    \
    DOTPRODUCTC(sd1,sd2, c0,c1,c2,c3, r12)   ;\
    DOTPRODUCTC(sd1,sd2, c4,c5,c6,c7, r13)   ;\
    PACK(r12, r13, r14)                     ;\
    DOTPRODUCTC(sd1,sd2, c8,c9,c10,c11, r12) ;\
    DOTPRODUCTC(sd1,sd2, c12,c13,c14,c15, r13)   ;\
    PACK(r12, r13, r8)                      ;\
    ori    r14, 0, sd1                      ;\
    ori    r8, 0, sd2

#define MV3_MULC(c0,c1,c2,c3, c4,c5,c6,c7, c8,c9,c10,c11, c12,c13,c14,c15)    \
    MV_MULC(r0,r1, c0,c1,c2,c3, c4,c5,c6,c7, c8,c9,c10,c11, c12,c13,c14,c15)    ;\
    MV_MULC(r2,r3, c0,c1,c2,c3, c4,c5,c6,c7, c8,c9,c10,c11, c12,c13,c14,c15)    ;\
    MV_MULC(r4,r5, c0,c1,c2,c3, c4,c5,c6,c7, c8,c9,c10,c11, c12,c13,c14,c15)

// Test data
PACKC(0x0100, 0x0200, r0)
PACKC(0x0300, 0x0400, r1)
PACKC(0x0500, 0x0600, r2)
PACKC(0x0700, 0x0800, r3)
PACKC(0x0900, 0x0a00, r4)
PACKC(0x0a00, 0x0b00, r5)

//MV3_MULC(0x0100, 0x0100, 0x0100, 0x0100,
//         0x0100, 0x0100, 0x0100, 0x0100,
//         0x0100, 0x0100, 0x0100, 0x0100,
//         0x0100, 0x0100, 0x0100, 0x0100)
MV3_MULC(0x0100, 0x0000, 0x0000, 0x0000,
         0x0000, 0x0100, 0x0000, 0x0000,
         0x0000, 0x0000, 0x0100, 0x0000,
         0x0000, 0x0000, 0x0000, 0x0100)

storeqi 1
end

